<template>
  <!-- eslint-disable vue/no-v-html -->
  <div class="relative bg-secondary-100">
    <section
      v-if="!product"
      class="relative py-16 bg-secondary-100 skeleton animate-pulse"
    >
      <div class="container mx-auto">
        <div class="grid grid-cols-9 gap-10">
          <div class="col-span-5">
            <div class="flex items-center justify-end h-full">
              <div
                class="flex flex-col items-center justify-center w-full h-full"
              >
                <div
                  class="w-full h-full rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
              </div>
            </div>
          </div>
          <div class="col-span-4">
            <div class="flex flex-col justify-between">
              <div
                class="w-32 h-5 rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
              ></div>

              <div class="mt-10">
                <div
                  class="w-20 h-5 rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
                <div
                  class="w-2/3 h-8 mt-2 rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
              </div>

              <div class="mt-10">
                <div
                  class="w-20 h-5 rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
                <div
                  class="w-40 h-5 mt-2 rounded shadow-md w- bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
              </div>

              <div class="flex mt-20">
                <div
                  class="w-1/5 h-12 rounded shadow-md bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
                <div
                  class="w-4/5 h-12 ml-5 rounded shadow-md w- bg-gradient-to-r from-secondary-200 to-secondary-100"
                ></div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <section v-else class="py-16 pt-3 md:pt-16 bg-secondary-100">
      <div class="container mx-auto">
        <div class="grid grid-cols-9 gap-10">
          <!-- Gallery -->
          <div class="col-span-9 md:col-span-5">
            <div
              class="flex flex-col-reverse items-center justify-end md:flex-row"
            >
              <div
                class="flex flex-row flex-wrap items-center justify-around w-full mt-3 md:justify-start md:flex-col md:w-1/4 md:mr-3 md:mt-0"
              >
                <img
                  v-for="(image, index) in gallery"
                  :key="index"
                  :src="image"
                  width="100px"
                  alt=""
                  class="mb-3 shadow-md cursor-pointer first:ml-0 hover:opacity-100"
                  :class="[{ 'opacity-50': currentImage !== index }]"
                  @click="currentImage = index"
                />
              </div>
              <div class="w-full px-3 md:w-3/4 md:px-0">
                <img
                  :src="gallery[currentImage]"
                  :alt="product.name"
                  class="w-full mx-auto"
                />
              </div>
            </div>
          </div>

          <div class="flex items-center col-span-9 px-5 md:col-span-4 md:px-0">
            <div class="flex flex-col justify-between">
              <!-- Top -->
              <div>
                <!-- SKU -->
                <div v-if="variationSelection !== null">
                  <span class="mr-2 text-secondary-200">SKU:</span>
                  <span class="uppercase text-secondary-400">
                    {{ variations[variationSelection].sku }}
                  </span>
                </div>

                <!-- <div v-if="product" class="border-t">
                  Type: {{ product.type }} <br />
                  Product: {{ product.databaseId }} <br />
                  <client-only v-if="variationSelection !== null">
                    Variation: {{ variations[variationSelection].databaseId }}
                    <br />

                  </client-only>
                  Qty: {{ qty }}
                </div> -->

                <!-- Name -->
                <div class="mt-10">
                  <!-- TODO: Add link to brand page -->
                  <h1 class="text-sm font-semibold text-secondary-300">
                    {{
                      product.name
                        .split(' - ')[1]
                        .replace(/--/g, '')
                        .replace(/_/g, ' ')
                    }}
                  </h1>
                  <span class="text-4xl font-semibold text-black">
                    {{ product.name.split(' - ')[0] }}
                  </span>

                  <div class="mt-2">
                    <span
                      v-for="(category, index) in product.productCategories
                        .nodes"
                      :key="index"
                      class="px-2 py-1 m-1 text-white rounded bg-primary-300"
                    >
                      {{ category.name }}
                    </span>
                  </div>
                </div>

                <!-- Price -->
                <div
                  v-if="variationSelection !== null"
                  id="prices"
                  class="mt-10"
                >
                  <span class="block mb-1 mr-2 text-secondary-200">Price:</span>
                  <div class="col-span-1">
                    <p
                      v-if="!variations[variationSelection].onSale"
                      class="text-3xl font-semibold leading-none"
                      title="Price"
                    >
                      US{{ variations[variationSelection].price }}
                    </p>

                    <p v-else class="text-3xl font-semibold leading-none">
                      <span title="Sale price">
                        US{{ variations[variationSelection].salePrice }}
                      </span>
                      <del
                        class="ml-3 text-base text-secondary-200"
                        title="Regular price"
                      >
                        US{{ variations[variationSelection].regularPrice }}
                      </del>
                    </p>
                  </div>
                </div>
                <div v-else class="mt-10">
                  <span class="block mb-1 mr-2 text-secondary-200">Price:</span>
                  <div class="col-span-1">
                    <p
                      v-if="!product.onSale"
                      class="text-3xl font-semibold leading-none"
                      title="Price"
                    >
                      US{{ product.price }}
                    </p>

                    <p v-else class="text-3xl font-semibold leading-none">
                      <span title="Sale price">
                        US{{ product.salePrice }}
                      </span>
                      <del
                        class="ml-3 text-base text-secondary-200"
                        title="Regular price"
                      >
                        US{{ product.regularPrice }}
                      </del>
                    </p>
                  </div>
                </div>

                <!-- Variations -->
                <div v-if="variations" class="mt-5">
                  <client-only v-if="variations.length > 0">
                    <span class="block mb-1 mr-2 text-secondary-200">
                      Size:
                    </span>
                    <div
                      class="flex flex-wrap items-center justify-start col-span-1"
                    >
                      <label
                        v-for="(variation, index) in variations"
                        :key="index"
                        class="relative p-1 overflow-hidden cursor-pointer variation-btn"
                        :for="variation.databaseId"
                        @click="variationSelection = index"
                      >
                        <span
                          class="btn base"
                          :class="[
                            { primary: index === variationSelection },
                            { secondary: index !== variationSelection },
                          ]"
                        >
                          {{ variation.attributes.nodes[0].value }}
                        </span>
                      </label>
                    </div>
                  </client-only>
                </div>
              </div>

              <!-- Bottom -->
              <div class="mt-20">
                <!-- Stack -->
                <!-- When not tmpQty -->
                <div>
                  <span
                    v-if="variations && variationSelection !== null"
                    class="block mb-2 text-sm text-secondary-300"
                  >
                    <span v-if="qty <= max">
                      <strong>
                        {{ variations[variationSelection].stockQuantity }}
                      </strong>
                      left in inventory
                    </span>

                    <span v-if="qty > max" class="text-secondary-300">
                      There are just
                      {{ variations[variationSelection].stockQuantity }} left in
                      inventory
                    </span>

                    <span v-if="qty < 1" class="text-primary-300">
                      The least amount is 1
                    </span>
                  </span>

                  <span v-else class="block mb-2 text-sm text-secondary-300">
                    <span v-if="qty >= 1 && qty <= max">
                      <strong>
                        {{ product.stockQuantity }}
                      </strong>
                      left in inventory
                    </span>

                    <span v-if="qty > max" class="text-primary-300">
                      <client-only v-if="variations">
                        <client-only v-if="variations.length === 0">
                          OUT OF STOCK
                        </client-only>
                        <client-only v-else>
                          There are just {{ product.stockQuantity }} left in
                          inventory
                        </client-only>
                      </client-only>
                      <client-only v-else> OUT OF STOCK </client-only>
                    </span>

                    <span v-if="qty < 1" class="text-primary-300">
                      The least amount is 1
                    </span>
                  </span>
                </div>

                <div id="itemsCounter" class="flex items-center justify-start">
                  <!-- Qty Input -->
                  <input
                    v-model.number="qty"
                    type="number"
                    min="1"
                    :max="max"
                    class="w-32 py-2 text-2xl text-center form-input"
                  />

                  <!-- Add Button -->
                  <button
                    class="ml-5 whitespace-no-wrap btn large"
                    :class="[
                      {
                        primary: qty <= max,
                      },
                      {
                        'secondary opacity-50 pointer-events-none':
                          qty > max || qty < 1,
                      },
                    ]"
                    @click="addToCart"
                  >
                    <span class="text-sm md:text-lg">Add to cart</span>
                    <i class="ml-3 text-2xl bx bxs-cart-add"></i>
                  </button>
                </div>

                <div v-if="errors" class="mt-5">
                  <span
                    class="text-xs text-primary-300"
                    v-html="errors.message"
                  />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>

    <section class="relative py-16 bg-white shadow-md">
      <div class="container mx-auto">
        <div class="grid grid-cols-3 gap-10">
          <div
            class="flex items-center justify-center col-span-3 md:justify-start md:col-span-1"
          >
            <div class="col-span-3 md:col-span-1">
              <img
                src="/icons/pretection.svg"
                width="75px"
                alt="Customer Protection Icon"
              />
            </div>
            <div class="col-span-3 ml-5 md:col-span-1">
              <h3 class="text-3xl font-light leading-none text-black">
                <span class="font-semibold">Protection</span> <br />
                <span class="text-2xl">for customers</span>
              </h3>
            </div>
          </div>

          <div
            class="flex items-center justify-center col-span-3 md:justify-start md:col-span-1"
          >
            <div>
              <img
                src="/icons/shipping.svg"
                width="60px"
                alt="Customer Protection Icon"
              />
            </div>
            <div class="ml-5">
              <h3 class="text-3xl font-light leading-none text-black">
                <span class="font-semibold">Free</span> <br />
                <span class="text-2xl">worldwide shipping</span>
              </h3>
            </div>
          </div>

          <div
            class="flex items-center justify-center col-span-3 md:justify-start md:col-span-1"
          >
            <div>
              <img
                src="/icons/safe-refound.svg"
                width="35px"
                alt="Customer Protection Icon"
              />
            </div>
            <div class="ml-5">
              <h3 class="text-3xl font-light leading-none text-black">
                <span class="font-semibold">Secure shopping</span> <br />
                <span class="text-2xl">Easy returns and refunds</span>
              </h3>
            </div>
          </div>
        </div>
      </div>
    </section>

    <section v-if="product" id="descriptions" class="py-16 bg-secondary-100">
      <div class="container mx-auto">
        <div class="px-10 pb-3 mb-6 border-b-2 border-secondary-200">
          <ul class="flex items-center justify-start">
            <li
              v-for="(nav, index) in switcher.nav"
              :key="index"
              class="ml-10 text-2xl first:ml-0 hover:text-black"
              :class="[
                { 'text-primary-300': switcher.current === index },
                { 'text-secondary-300': switcher.current !== index },
              ]"
            >
              <button class="outline-none" @click="switcher.current = index">
                {{ nav.label }}
              </button>
            </li>
          </ul>
        </div>
        <div class="p-10 bg-white rounded-lg shadow-md">
          <client-only v-if="switcher.current === 0">
            <!-- eslint-disable-next-line vue/no-v-html -->
            <div
              class="prose prose-lg prose-primary-300"
              v-html="product.description"
            ></div>
          </client-only>
          <!-- <client-only v-if="switcher.current === 1">
            <ul>
              <li>
                <span>Length:</span>
                <span class="ml-5">
                  {{ product.length }}
                </span>
              </li>

              <li>
                <span>height:</span>
                <span class="ml-5">
                  {{ product.height }}
                </span>
              </li>

              <li>
                <span>weight:</span>
                <span class="ml-5">
                  {{ product.weight }}
                </span>
              </li>

              <li>
                <span>width:</span>
                <span class="ml-5">
                  {{ product.width }}
                </span>
              </li>
            </ul>
          </client-only> -->
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import unserialize from 'locutus/php/var/unserialize'
import _filter from 'lodash/filter'

import getProduct from '~/apollo/queries/products/getProduct.gql'
import getProductVariations from '~/apollo/queries/products/getProductVariations.gql'

export default {
  data() {
    return {
      qty: 1,
      tmpQty: null,
      variationSelection: null,
      currentImage: 0,
      switcher: {
        nav: [{ label: 'Description' }],
        current: 0,
      },
    }
  },
  computed: {
    errors() {
      return this.$store.state.cart.errors || null
    },
    gallery() {
      return unserialize(this.product.productImages.gallery)
    },
    max() {
      if (this.product.type !== 'VARIABLE') {
        return this.product.stockQuantity
      } else {
        return this.variationSelection !== null
          ? this.variations[this.variationSelection].stockQuantity
          : ''
      }
    },
  },
  methods: {
    setCart() {
      this.$store.dispatch('cart/setCart', {
        item: {
          productId: this.product.databaseId,
          variationId: this.variations
            ? this.variations[this.variationSelection].databaseId
            : null,
          quantity: this.qty,
        },
        coupons: [],
        type: this.product.type,
        redirectTo: this.$route.path,
      })
    },
    addToCart() {
      const that = this
      const match = _filter(this.$store.state.cart.items, function (o) {
        return !!(
          o.productId === that.product.databaseId &&
          o.variationId ===
            (that.variations
              ? that.variations[that.variationSelection].databaseId
              : null)
        )
      })

      if (match.length > 0) {
        const tmpQty =
          this.product.type === 'VARIABLE'
            ? this.variations[this.variationSelection].stockQuantity
            : this.product.stockQuantity

        if (match[0].quantity + this.qty > tmpQty) {
          let message = `You cannot add that amount of "${this.product.name}" to the cart because there is not enough stock (${tmpQty} remaining`

          if (this.variations) {
            message = `You cannot add that amount of "${
              this.product.name
            }" size ${
              this.variations[this.variationSelection].attributes.nodes[0].value
            } to the cart because there is not enough stock (${tmpQty} remaining)
            `
          }

          this.$store.dispatch('cart/setError', {
            message,
            type: 'FAILED_ADD_TO_CART',
          })
          this.tmpQty = tmpQty
        } else {
          this.setCart()
        }
      } else {
        this.setCart()
      }

      if (this.product.type === 'VARIABLE') this.variationSelection = null
    },
  },
  apollo: {
    product: {
      prefetch: true,
      query: getProduct,
      variables() {
        return {
          id: this.$route.params.slug,
        }
      },
      update(data) {
        return data.product
      },
    },
    variations: {
      prefetch: false,
      query: getProductVariations,
      variables() {
        return {
          id: this.$route.params.slug,
        }
      },
      update(data) {
        // console.log(data)
        return data.product.variations.nodes
      },
      skip() {
        return this.$route.params.productType
          ? this.$route.params.productType !== 'VARIABLE'
          : this.product.type !== 'VARIABLE'
      },
    },
  },
}
</script>
